#!/bin/bash


ifconfig eth0 192.168.0.1
sleep 2

sleep 2
ifconfig wlan0 192.168.2.61
sleep 2
route add default gw 192.168.2.1
route add -net 192.168.2.0 netmask 255.255.255.0 gw 192.168.2.61
sleep 2


if ( ps -e | grep "httpd" ) then
  echo "Apache is running"
else
  echo "Starting Apache."
  /usr/local/httpd-2.4.33/httpd
fi


if ( ps -e | grep "R12C1" ) then
  echo "R12C1 is running"
else
  echo "Starting R12C1."
  cd /usr/local/apache2/htdocs/scripts
  ./R12C1 &
fi


