#! /usr/bin/perl

use strict;
#use CGI qw(:standard);
#use CGI::Carp qw(fatalsToBrowser);

my $type_style =  '; font-family:serif,Times,serif; font-size:12px; color:#000000"';
my $type_style_large =  '; font-family:serif,Times,serif; font-size:20px; color:#000000"';


my ($Command) = @ARGV;

my $BatteryStatus = "Nothing yet...";

if (not defined $Command) {
  $Command = "NoCommand";
}

print "Content-type: text/html\n\n";
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">' . "\n";
print "<html><head><title>CNC commands received</title>" . "\n";

print "</head><body>";
print '<table border="0" cellpadding="0" cellspacing="0"><tr>' . "\n";


open(FILEIN, "<" . "Battery.txt") || die "Can not open file Battery.txt!\n";
  $BatteryStatus = <FILEIN>;
close(FILEIN);

if(index($Command, "ShutDown") == 0){
  print '<td style="background-color:#FF9999' . $type_style . '">Shutting down R12!!!</td></tr>';
  print '<td style="background-color:#FF99FF' . $type_style . '">' . $BatteryStatus . '</td></tr></table></body></html>';
  open(DATEIOUT,'>Commands.tmp') || die '<td style="background-color:#FF0000' . $type_style . '>Can not open commands.tmp file Please try again.</td></tr></table></body></html>';
    print DATEIOUT $Command;
  close (DATEIOUT);
  `mv Commands.tmp Commands.txt`;
  exit(0);
}

if(index($Command, "Start") == 0){
  if(!(-e "R12_CommandFree.bmp")){#Rover is locked
    ExecuteCommandLine("killall R12C1", 0);
    ExecuteCommandLine("cp IndicationPicture.bmp R12_CommandFree.bmp", 0);
  }
  print '<td style="background-color:#99FF99' . $type_style . '">Commands.tmp removed.</td></tr>';
  print '<td style="background-color:#FF99FF' . $type_style . '">' . $BatteryStatus . '</td></tr></table></body></html>';
  exit(0);
}

if(!(-e "R12_CommandFree.bmp")){#Last command not yet processed
  print '<td style="background-color:#FF9999' . $type_style . '">Wait until last command is processed!</td></tr>';
  print '<td style="background-color:#99FFFF' . $type_style . '">' . $BatteryStatus . '</td></tr></table></body></html>';
  exit(0);
}

if(index($Command, "NoCommand") == 0){
  if(!(-e "Commands.tmp")){#Rover is free
    print '<td style="background-color:#99FFFF' . $type_style . '">Rover is waiting for a command...</td></tr>';
    print '<td style="background-color:#99FFFF' . $type_style . '">' . $BatteryStatus . '</td></tr></table></body></html>';
    exit(0);
  }
}

open(DATEIOUT,'>Commands.tmp') || die '<td style="background-color:#FF0000' . $type_style . '>Can not open commands.tmp file Please try again.</td></tr></table></body></html>';
  print DATEIOUT $Command;

  if(substr($Command, 0, 6) eq "SendCm"){
    &SetTimeStamp();
    print '<td style="background-color:#99FF99' . $type_style . '">Received command "' . $Command . '".</td></tr>';
    print '<td style="background-color:#99FFFF' . $type_style . '">' . $BatteryStatus . '</td></tr></table></body></html>';
  }#if(substr($Command, 0, 5) eq "Comnd"){
  else{
    print '<td style="background-color:#00FF00' . $type_style . '">Nothing received?</td></tr>';
    print '<td style="background-color:#99FFFF' . $type_style . '">' . $BatteryStatus . '</td></tr></table></body></html>';
  }

close (DATEIOUT);
`mv Commands.tmp Commands.txt`;




exit (0);

#++++++++++++++++++++++ ExecuteCommandLine ++++++++++++++++++++++++++++++++++++++++++++++++++
sub ExecuteCommandLine{
  print $_[0] . "\n";
  if($_[1] == 0){
    `$_[0]`;
  }
  else{
#    `$_[0]`;
    system ($_[0] . "&");
  }
}

#++++++++++++++++++++++ SetTimeStamp ++++++++++++++++++++++++++++++++++++++++++++++++++
sub SetTimeStamp{
  open(DATEIOUT,'>TimeStamp.tmp') || die '<td style="background-color:#FF0000' . $type_style . '>Can not open TimeStamp.tmp file Please try again.</td></tr></table></body></html>';
    print DATEIOUT time();
  close (DATEIOUT);
  `mv TimeStamp.tmp TimeStamp.txt`;
}

